/* qsfpr.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__2 = 2;

/* Subroutine */ int qsfpr_c(C_fp fun, real *a, real *b, real *abserr,
        real *relerr, real *t, real *result, real *errest, integer *nofun,
        real *flag__)
{
    /* System generated locals */
    integer i__1;
    real r__1, r__2, r__3;
    complex q__1, q__2, q__3;

    /* Builtin functions */
    integer pow_ii(integer *, integer *);
    double sin(doublereal), cos(doublereal);

    /* Local variables */
    static real alfa, gama, area, beta, cor11, temp, step, qnow;
    static integer i__, j;
    static real x[16], qdiff;
    static integer nofin;
    static real qleft;
    static integer nomax;
    static real xsave[240]      /* was [8][30] */;
    static complex f0;
    static real stone;
    static complex f1;
    static real c7, c8, qprev, x0, s7, s8, c15, c16, fi[16];
    static complex fj;
    static real ta, cs[16], tb, fr[16], s15, s16, tc, sn[16];
    static complex zi;
    static real tt, fisave[240] /* was [8][30] */,
             frsave[240]  /* was [8][30] */;
    static integer levmin, levmax;
    static real qright[31], fi0, esterr, cs0, tolerr, fr0;
    static integer levout;
    static real sn0;
    static integer nim, lev;

#define xsave_ref(a_1,a_2) xsave[(a_2)*8 + a_1 - 9]
#define fisave_ref(a_1,a_2) fisave[(a_2)*8 + a_1 - 9]
#define frsave_ref(a_1,a_2) frsave[(a_2)*8 + a_1 - 9]

    zi.r = 0.f, zi.i = 1.f;
    levmin = 1;
    levmax = 30;
    levout = 6;
    nomax = 5000;
    i__1 = levout + 1;
    nofin = nomax - (levmax - levout + pow_ii(&c__2, &i__1) << 3);
    *flag__ = 0.f;
    *result = 0.f;
    cor11 = 0.f;
    *errest = 0.f;
    area = 0.f;
    *nofun = 0;
    if (*a == *b) {
        goto L220;
    }
    lev = 0;
    nim = 1;
    x0 = *a;
    x[15] = *b;
    qprev = 0.f;
    (*fun)(&q__1, &x0);
    f0.r = q__1.r, f0.i = q__1.i;
    fr0 = f0.r;
    q__2.r = -zi.r, q__2.i = -zi.i;
    (*fun)(&q__3, &x0);
    q__1.r = q__2.r * q__3.r - q__2.i * q__3.i, q__1.i = q__2.r * q__3.i + 
            q__2.i * q__3.r;
    fi0 = q__1.r;
    stone = (*b - *a) / 16.f;
    x[7] = (x0 + x[15]) / 2.f;
    x[3] = (x0 + x[7]) / 2.f;
    x[11] = (x[7] + x[15]) / 2.f;
    x[1] = (x0 + x[3]) / 2.f;
    x[5] = (x[3] + x[7]) / 2.f;
    x[9] = (x[7] + x[11]) / 2.f;
    x[13] = (x[11] + x[15]) / 2.f;
    for (j = 2; j <= 16; j += 2) {
        (*fun)(&q__1, &x[j - 1]);
        fj.r = q__1.r, fj.i = q__1.i;
        i__1 = j - 1;
        fr[i__1] = fj.r;
        i__1 = j - 1;
        q__2.r = -zi.r, q__2.i = -zi.i;
        q__1.r = q__2.r * fj.r - q__2.i * fj.i, q__1.i = q__2.r * fj.i + 
                q__2.i * fj.r;
        fi[i__1] = q__1.r;
/* L10: */
    }
    *nofun = 9;
L20:
    x[0] = (x0 + x[1]) / 2.f;
    (*fun)(&q__1, x);
    f1.r = q__1.r, f1.i = q__1.i;
    fr[0] = f1.r;
    q__2.r = -zi.r, q__2.i = -zi.i;
    q__1.r = q__2.r * f1.r - q__2.i * f1.i, q__1.i = q__2.r * f1.i + q__2.i * 
            f1.r;
    fi[0] = q__1.r;
    for (j = 3; j <= 15; j += 2) {
        x[j - 1] = (x[j - 2] + x[j]) / 2.f;
        (*fun)(&q__1, &x[j - 1]);
        fj.r = q__1.r, fj.i = q__1.i;
        i__1 = j - 1;
        fr[i__1] = fj.r;
        i__1 = j - 1;
        q__2.r = -zi.r, q__2.i = -zi.i;
        q__1.r = q__2.r * fj.r - q__2.i * fj.i, q__1.i = q__2.r * fj.i + 
                q__2.i * fj.r;
        fi[i__1] = q__1.r;
/* L30: */
    }
    *nofun += 8;
    step = (x[15] - x0) / 16.f;
    tt = *t * step;
    if (tt <= .001f) {
        goto L40;
    }
    ta = (real)sin((real)(tt * 2.f));
    tb = (real)sin(tt);
    tc = (real)cos(tt);
/* Computing 2nd power */
    r__1 = tb / tt;
    alfa = (ta / (tt * 2.f) + 1.f - r__1 * r__1 * 2.f) / tt;
/* Computing 2nd power */
    r__1 = tc;
/* Computing 2nd power */
    r__2 = tt;
    beta = (r__1 * r__1 + 1.f - ta / tt) * 2.f / (r__2 * r__2);
/* Computing 2nd power */
    r__1 = tt;
    gama = (tb / tt - tc) * 4.f / (r__1 * r__1);
    goto L50;
L40:
/* Computing 2nd power */
    r__1 = tt;
/* Computing 4th power */
    r__2 = tt, r__2 *= r__2;
/* Computing 3rd power */
    r__3 = tt;
    alfa = (.022222222222222223f - r__1 * r__1 / 315.f + r__2 * r__2 / 4725.f)
             * 2.f * (r__3 * (r__3 * r__3));
/* Computing 2nd power */
    r__1 = tt;
/* Computing 2nd power */
    r__2 = tt;
/* Computing 4th power */
    r__3 = tt, r__3 *= r__3;
    beta = (r__1 * r__1 * (.066666666666666666f - r__2 * r__2 * 2.f / 105.f + 
            r__3 * r__3 / 567.f) + .33333333333333331f) * 2.f;
/* Computing 2nd power */
    r__1 = tt;
/* Computing 2nd power */
    r__2 = tt;
/* Computing 4th power */
    r__3 = tt, r__3 *= r__3;
    gama = 1.3333333333333333f - r__1 * r__1 * (.13333333333333333f - r__2 * 
            r__2 / 210.f + r__3 * r__3 / 11340.f);
L50:
    c8 = 0.f;
    s8 = 0.f;
    c7 = 0.f;
    s7 = 0.f;
    cs0 = (real)cos((real)(*t * x0));
    sn0 = (real)sin((real)(*t * x0));
    for (j = 1; j <= 16; ++j) {
        cs[j - 1] = (real)cos((real)(*t * x[j - 1]));
        sn[j - 1] = (real)sin((real)(*t * x[j - 1]));
/* L60: */
    }
    for (j = 2; j <= 6; j += 2) {
        c8 += fr[j - 1] * cs[j - 1];
        s8 += fi[j - 1] * sn[j - 1];
/* L70: */
    }
    c8 += (fr0 * cs0 + fr[7] * cs[7]) / 2.f;
    s8 += (fi0 * sn0 + fi[7] * sn[7]) / 2.f;
    c16 = 0.f;
    s16 = 0.f;
    for (j = 10; j <= 14; j += 2) {
        c16 += fr[j - 1] * cs[j - 1];
        s16 += fi[j - 1] * sn[j - 1];
/* L80: */
    }
    c16 += (fr[7] * cs[7] + fr[15] * cs[15]) / 2.f;
    s16 += (fi[7] * sn[7] + fi[15] * sn[15]) / 2.f;
    c7 = 0.f;
    s7 = 0.f;
    for (j = 1; j <= 7; j += 2) {
        c7 += fr[j - 1] * cs[j - 1];
        s7 += fi[j - 1] * sn[j - 1];
/* L90: */
    }
    c15 = fr[8];
    s15 = fi[8] * sn[8];
    for (j = 11; j <= 15; j += 2) {
        c15 += fr[j - 1] * cs[j - 1];
        s15 += fi[j - 1] * sn[j - 1];
/* L100: */
    }
    qleft = step * (alfa * (fr[7] * sn[7] + fi[7] * cs[7] - fr0 * sn0 -
            fi0 * cs0) + beta * (c8 - s8) + gama * (c7 - s7));
    qright[lev] = step * (alfa * (fr[15] * sn[15] + fi[15] * cs[15] - fr[7] * 
            sn[7] - fi[7] * cs[7]) + beta * (c16 - s16) + gama * (c15 - s15));
    qnow = qleft + qright[lev];
    qdiff = qnow - qprev;
    area += qdiff;
    esterr = abs(qdiff) / 7.f;
/* Computing MAX */
    r__1 = *abserr, r__2 = *relerr * abs(area);
    tolerr = max(r__1,r__2) * (step / stone);
    if (lev < levmin) {
        goto L110;
    }
    if (lev >= levmax) {
        goto L150;
    }
    if (*nofun > nofin) {
        goto L140;
    }
    if (esterr <= tolerr) {
        goto L160;
    }
L110:
    nim <<= 1;
    ++lev;
    for (i__ = 1; i__ <= 8; ++i__) {
        frsave_ref(i__, lev) = fr[i__ + 7];
        fisave_ref(i__, lev) = fi[i__ + 7];
        xsave_ref(i__, lev) = x[i__ + 7];
/* L120: */
    }
    qprev = qleft;
    for (i__ = 1; i__ <= 8; ++i__) {
        j = -i__;
        fr[(j << 1) + 17] = fr[j + 8];
        fi[(j << 1) + 17] = fi[j + 8];
        x[(j << 1) + 17] = x[j + 8];
/* L130: */
    }
    goto L20;
L140:
    nofin <<= 1;
    levmax = levout;
    *flag__ += (*b - x0) / (*b - *a);
    goto L160;
L150:
    *flag__ += 1.f;
L160:
    *result += qnow;
    *errest += esterr;
    cor11 += qdiff / 7.f;
L170:
    if (nim == nim / 2 << 1) {
        goto L180;
    }
    nim /= 2;
    --lev;
    goto L170;
L180:
    ++nim;
    if (lev <= 0) {
        goto L200;
    }
    qprev = qright[lev - 1];
    x0 = x[15];
    fr0 = fr[15];
    fi0 = fi[15];
    for (i__ = 1; i__ <= 8; ++i__) {
        fr[(i__ << 1) - 1] = frsave_ref(i__, lev);
        fi[(i__ << 1) - 1] = fisave_ref(i__, lev);
        x[(i__ << 1) - 1] = xsave_ref(i__, lev);
/* L190: */
    }
    goto L20;
L200:
    *result += cor11;
    if (*errest == 0.f) {
        goto L220;
    }
L210:
    temp = abs(*result) + *errest;
    if (temp != abs(*result)) {
        goto L220;
    }
    *errest *= 2.f;
    goto L210;
L220:
    return 0;
} /* qsfpr_c */

#undef frsave_ref
#undef fisave_ref
#undef xsave_ref
